﻿Imports System.IO
Imports Microsoft.Win32

Public Class FrmRegVorschau

    'Dieses Tool ist Freeware und kann entsprechend den eigenen Vorstellungen geändert werden!
    '(Es wurde erstellt mit Hilfe von Tipps des vbarchivs (Dieter) und vbfun)

    'dieses kleine Tool ermöglicht die Vorschau wie die des aktuellen Internet-Explorers in HTML-Editoren
    'da diese standardmäßig die Vorschau des IE-7 nutzen
    'und kann hiermit entsprechend geändert werden
    'es wurde an 2 Freeware HTML-Editoren erfolgreich getestet
    'das bedeutet aber nicht das es bei "allen" HTML-Editoren funktioniert
    '(einfach auf eigenes Risiko testen)
    '(getestet mit dem Betriebssystem: WinXP Sp3)

    'Für evtl. auftretende Schäden jeglicher Art wird nicht gehaftet!!!

    Private Const sRegistrySubKeyObject As String = "Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION"
    Private Const vbQuote As String = """"
    Dim sPath As String

#Region "vorhandene HTML-Editoren auflisten"
    Private Sub ListItems_FEATURE_BROWSER_EMULATION()
        'Dieser Source stammt von http://www.vb-fun.de und kann frei
        'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
        'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
        'Quellenangabe veröffentlicht werden (siehe hierzu auch die
        'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
        'Für eventuelle Schäden wird nicht gehaftet.

        'Um Fehler oder Fragen zu klären, nutzen Sie bitte unser Forum.
        'Ansonsten viel Spaß und Erfolg mit diesem Source-Code !

        'wurde für dieses Projekt leicht geändert!

        My.Application.DoEvents()

        'Im Hauptschlüssel HKEY_CURRENT_USER
        'wird der Unterschlüssel "Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION" ausgelesen.
        Dim SubKey As String = sRegistrySubKeyObject
        Dim Key As RegistryKey = Registry.CurrentUser.OpenSubKey(SubKey, False)
        'GetValueNames ruft ein Array von Zeichenfolgen ab, das die Namen aller diesem Schlüssel 
        'zugeordneten Werte enthält. 
        Dim ValueNames As String() = Key.GetValueNames

        With Me.lstRegKeyValue
            .Items.Clear()

            For Each sName As String In ValueNames
                .Items.Add(sName)
            Next
        End With

        Key.Close()
    End Sub
#End Region

#Region "Laufwerk auf Typ und Verfügbarkeit prüfen"
    Private Function IsDriveReady(ByVal sDrive As String) As Boolean
        'aus dem vbarchiv
        ' Prüft, ob das angegebene Laufwerk existiert und 
        ' ob darauf zugegriffen werden kann
        Try
            Dim oDrive As New System.IO.DriveInfo(sDrive)
            Return oDrive.IsReady
        Catch ex As Exception
            Return False
        End Try
    End Function

    Private Function IsNotCDDrive(ByVal sDrive As String) As Boolean
        'aus dem vbarchiv
        ' Prüft, ob das angegebene Laufwerk ein CD-Rom Laufwerk ist und 
        ' ob somit darauf zugegriffen werden kann
        Try
            Dim oDrive As New System.IO.DriveInfo(sDrive)
            If oDrive.DriveType <> DriveType.CDRom Then
                Return True
            Else
                Return False
            End If

        Catch ex As Exception
            Return False
        End Try
    End Function
#End Region

#Region "Registrierungs-Datei speichern, öffnen und `starten`"
    Private Sub SaveFile(ByVal sFileName As String, ByVal sText As String)
        'speichert die entsprechende Registrierungs-Datei
        Try
            Dim sDrive As String = Strings.Left(sFileName, 2)

            If IsDriveReady(sDrive) Then
                If IsNotCDDrive(sDrive) Then
                    Using sw As IO.StreamWriter = New IO.StreamWriter(sFileName)
                        sw.Write(sText)
                        sw.Close()
                        sw.Dispose()
                    End Using
                End If
            End If

        Catch ex As Exception

        End Try
    End Sub

    'Tipp von Dieter
    ''' <summary>
    ''' Öffnet das Dokument mit der im System festgelegten Standard-Anwendung
    ''' </summary>
    ''' <param name="DocumentFile">Dokument-Dateiname</param>
    ''' <returns>True, wenn das Dokument geöffnet werden konnte, andernfalls False.</returns>
    Private Function OpenDocument(ByVal DocumentFile As String) As Boolean
        Try
            Dim pInfo As New Diagnostics.ProcessStartInfo
            With pInfo
                ' Dokument
                .FileName = DocumentFile

                ' verknüpfte Anwendung starten
                .Verb = "open"
            End With
            Process.Start(pInfo)
            Return True

        Catch ex As Exception
            Return False
        End Try
    End Function
#End Region

#Region "Internet-Explorer-Version ermitteln"
    'Tipp von Dieter: Version des Internet Explorers ermitteln
    ''' <summary>
    ''' Ermittelt die Versions-Nr. des Internet Explorers
    ''' </summary>
    ''' <returns>Versions-Nr. als String</returns>
    Private Function IEVersion() As String 'Versionsnummer als String
        Dim sVersion As String = ""

        ' IE-Version aus Registry auslesen
        Using RegKey As RegistryKey = Registry.LocalMachine.OpenSubKey( _
          "Software\Microsoft\Internet Explorer", False)

            If Not IsNothing(RegKey) Then
                sVersion = CType(RegKey.GetValue("Version"), String)
            End If
        End Using

        Return sVersion
    End Function

    ''' <summary>
    ''' Ermittelt die Versions-nr. des Internet Explorers
    ''' </summary>
    ''' <returns>Version-Objekt</returns>
    Private Function IEVersionInfo() As Version 'Versionsnummer als Objekt
        Dim sVersion As String = IEVersion()
        If sVersion.Length > 0 Then
            Return New Version(sVersion)
        Else
            Return Nothing
        End If
    End Function
#End Region

#Region "Registrierungsdatei erstellen"
    Private Sub CreateApplicationRegistryFile(ByVal Applicationname As String, ByVal Registryfilename As String)
        'erzeugt und "startet" die entsprechende Registrierungsdatei für die IE-"IEVer.Major" Vorschau
        Try

            'die Internet-Explorer Version ermitteln
            Dim IEVer As Version = IEVersionInfo()

            Dim sReg As String = "Windows Registry Editor Version 5.00" & vbCrLf _
            & "[HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION]" _
            & vbCrLf & vbQuote & Applicationname & vbQuote & "=dword:" & Hex(IEVer.Major * 1000)
            'z.B. für die IE-8-Vorschau (Name=HTMLEditorname.exe Type=REG_DWORD Wert=0x00001F40 (8000))
            Call SaveFile(Registryfilename, sReg)
            If My.Computer.FileSystem.FileExists(Registryfilename) Then
                Call OpenDocument(Registryfilename)
            Else
                MsgBox("Die Registrierungsdatei für die IE" & IEVer.Major & " Vorschau konnte nicht erstellt werden!", MsgBoxStyle.Exclamation, "Fehler!")
            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler beim Erstellen der Registrierungsdatei")
        End Try
    End Sub
#End Region

#Region "Registry-Eintrag erstellen bzw. entfernen"
    Private Sub CreateRegIEVorschau(ByVal sAppName As String)
        'die Internet-Explorer Version ermitteln
        Dim IEVer As Version = IEVersionInfo()

        'beim Starten aus der IDE von Visual-Basic heraus wird noch die IE7 Vorschau genutzt
        Dim sRegFileName As String = sPath & sAppName & "_IE" & IEVer.Major & "_Vorschau.reg"

        Try

            Dim sDrive As String = Strings.Left(sPath, 2)

            If IsDriveReady(sDrive) Then
                If IsNotCDDrive(sDrive) Then
                    'nur ausführen wenn kein CD-Rom-Laufwerk

                    If My.Computer.FileSystem.FileExists(sRegFileName) = False Then
                        Call CreateApplicationRegistryFile(sAppName, sRegFileName)
                    Else

                        'den Registrierungseintrag zuvor suchen
                        Dim bolSubKeyObject As Object = Nothing
                        Try
                            bolSubKeyObject = (Registry.CurrentUser.OpenSubKey(sRegistrySubKeyObject))
                        Catch ex As Exception
                            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler in Registry.CurrentUser.OpenSubKey")
                        End Try

                        Dim sRegSubKey As RegistryKey
                        If IsNothing(bolSubKeyObject) Then
                            'den Registrierungseintrag erstellen
                            sRegSubKey = Registry.CurrentUser.CreateSubKey(sRegistrySubKeyObject)
                        End If
                        sRegSubKey = Registry.CurrentUser.OpenSubKey(sRegistrySubKeyObject)
                        Dim sAppRegKeyObject As Object = sRegSubKey.GetValue(sAppName)
                        sRegSubKey.Close()
                        'Prüfen ob der Eintrag existiert
                        If Not (sAppRegKeyObject Is Nothing) Then
                            'Registrierungs-Eintrag wurde gefunden
                            MsgBox("Die Internet-Explorer" & IEVer.Major & "-Vorschau für " & sAppName & " wird bereits verwendet!", MsgBoxStyle.Information)
                        Else 'Registrierungs-Eintrag wurde nicht gefunden
                            If My.Computer.FileSystem.FileExists(sRegFileName) Then
                                '"startet" die entsprechende Registrierungsdatei für die IE-"IEVer.Major" Vorschau
                                Call OpenDocument(sRegFileName)
                            Else
                                Call CreateApplicationRegistryFile(sAppName, sRegFileName)
                            End If
                        End If

                    End If
                Else
                    MsgBox("Von CD können keine Werte in die Registry eingetragen werden!", MsgBoxStyle.Exclamation, "falscher Laufwerks-Type (CD-Rom-Laufwerk)")
                End If
            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler beim Aktivieren der IE-" & IEVer.Major & "-Vorschau")
        End Try
    End Sub

    Public Sub DeleteRegIEVorschau(ByVal sAppName As String)
        'löscht den entsprechenden Eintrag (SubKey)
        Dim sDrive As String = Strings.Left(sPath, 2)

        'die Internet-Explorer Version ermitteln
        Dim IEVer As Version = IEVersionInfo()
        Dim sRegFileName As String = sPath & sAppName & "_IE" & IEVer.Major & "_Vorschau.reg"

        Try

            If IsDriveReady(sDrive) Then
                If IsNotCDDrive(sDrive) Then
                    'nur ausführen wenn kein CD-Rom-Laufwerk

                    'den Registrierungseintrag zuvor suchen
                    Dim bolSubKeyObject As Object = Nothing
                    Try
                        bolSubKeyObject = (Registry.CurrentUser.OpenSubKey(sRegistrySubKeyObject))
                    Catch ex As Exception
                    End Try

                    If IsNothing(bolSubKeyObject) Then
                        MsgBox("Der Registrierungs-Eintrag für die IE-" & IEVer.Major _
                               & "-Vorschau, von " & sAppName & " wurde bereits entfernt bzw. noch nicht aktiviert!", _
                               MsgBoxStyle.Information, "Registrierungs-Eintrag nicht gefunden")
                    Else
                        'den Registrierungseintrag löschen
                        Dim sRegKey As RegistryKey = Registry.CurrentUser.OpenSubKey(sRegistrySubKeyObject, True)
                        sRegKey.DeleteValue(sAppName)
                        sRegKey.Close()

                        'es kann auch das "SubKey"-Objekt gelöscht werden, ist aber nicht zu empfehlen
                        '(dadurch werden evtl. aber auch weitere Einträge anderer HTML-Editoren gelöscht)
                        'Registry.CurrentUser.DeleteSubKey(sRegistrySubKeyObject)

                        'die "Registry-Datei" ebenfalls löschen
                        If My.Computer.FileSystem.FileExists(sRegFileName) Then
                            My.Computer.FileSystem.DeleteFile(sRegFileName, FileIO.UIOption.OnlyErrorDialogs, _
                                                              FileIO.RecycleOption.SendToRecycleBin, _
                                                              FileIO.UICancelOption.ThrowException)
                        End If
                        MsgBox("Der Registrierungseintrag für die IE-" & IEVer.Major _
                               & "-Vorschau wurde erfolgreich entfernt!", _
                               MsgBoxStyle.Information, "Registrierungs-Eintrag entfernt")
                    End If

                End If

            Else
                MsgBox("Von CD können keine Werte in die Registry eingetragen werden!", MsgBoxStyle.Exclamation, "falscher Laufwerks-Type (CD-Rom-Laufwerk)")
            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler beim Deaktivieren der IE-" & IEVer.Major & "-Vorschau")
        End Try
    End Sub

    Private Sub cmdAktivieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAktivieren.Click
        'den entsprechenden Registry-Eintrag für die IE-Versions-Vorschau erstellen
        Call CreateRegIEVorschau(Me.txtHTMLEditorName.Text)
        My.Application.DoEvents()
        'die Liste updaten (funktioniert hier leider nicht, keine Ahnung warum?!?)
        Call ListItems_FEATURE_BROWSER_EMULATION()
        Me.cmdAktivieren.Enabled = False
    End Sub

    Private Sub cmdDeAktivieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDeAktivieren.Click
        'den entsprechenden Registry-Eintrag die IE-Versions-Vorschau entfernen
        With Me.lstRegKeyValue
            Call DeleteRegIEVorschau(.Items.Item(.SelectedIndex))
            My.Application.DoEvents()
            'die Liste updaten
            Call ListItems_FEATURE_BROWSER_EMULATION()
        End With
    End Sub

    Private Sub lstRegKeyValue_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstRegKeyValue.SelectedIndexChanged
        'den HTML-Editor wählen
        Dim IEVer As Version = IEVersionInfo()
        With Me
            .cmdDeAktivieren.Enabled = (.lstRegKeyValue.SelectedIndex >= 0)
            .cmdDeAktivieren.Text = "Vorschau IE-" & IEVer.Major & " für " _
            & UCase(.lstRegKeyValue.Items.Item(.lstRegKeyValue.SelectedIndex)) & " deaktivieren"
        End With
    End Sub
#End Region

    Private Sub FrmRegVorschau_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim IEVer As Version = IEVersionInfo()
        With Me
            If IsNothing(IEVer) OrElse IEVer.Major < 7 Then
                .Text = "Die Anwendung erfordert den IE in der Version 7 oder höher!"
                .lblHinweis.Text = .Text
                .cmdHTMLEditor.Enabled = False
                .cmdDeAktivieren.Enabled = False
                'MsgBox("Die Anwendung erfordert den IE in der Version 7 oder höher!")
            Else
                .Text = "IE-" & IEVer.Major & " Vorschau in HTML-Editoren de-/aktivieren"
                .lblHinweis.Text = "Ermöglicht die Vorschau wie die" & vbCrLf & "des akt. Internet-Explorers " & IEVer.Major _
                & vbCrLf & "für/in HTML-Editoren zu de- bzw. zu aktivieren!"
                .cmdAktivieren.Text = "IE-" & IEVer.Major & " Vorschau in HTML-Editoren aktivieren"
                .cmdDeAktivieren.Text = "Vorschau IE-" & IEVer.Major & " deaktivieren"
                .cmdDeAktivieren.Enabled = False
            End If
        End With

        sPath = My.Application.Info.DirectoryPath.ToString
        If Strings.Right(sPath, 1) <> "\" Then
            sPath = sPath & "\"
        End If

        'die HTML-Editoren auflisten
        Call ListItems_FEATURE_BROWSER_EMULATION()
    End Sub

    Private Sub cmdHTMLEditor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHTMLEditor.Click
        'den HTML-Editor für die IE-Versions-Vorschau wählen
        Dim myOpenFileDialog As New OpenFileDialog
        With myOpenFileDialog
            .Title = "HTML-Editor wählen"
            .Filter = "HTML-Editoren *.exe|*.exe"
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.ProgramFiles
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                If .FileName <> "" Then
                    If My.Computer.FileSystem.FileExists(.FileName) Then
                        Dim IEVer As Version = IEVersionInfo()

                        Me.txtHTMLEditorName.Text = Strings.Mid(.FileName, InStrRev(.FileName, "\") + 1)
                        Me.txtHTMLEditorName.Tag = .FileName
                        Me.cmdAktivieren.Enabled = True
                        Me.cmdAktivieren.Text = "Vorschau IE-" & IEVer.Major & " für " & UCase(Me.txtHTMLEditorName.Text) & " aktivieren"

                    End If
                End If
            End If
        End With
    End Sub

    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        With Me.TabControl1
            Select Case .SelectedIndex
                Case 1
                    Dim IEVer As Version = IEVersionInfo()

                    'die Liste updaten
                    Call ListItems_FEATURE_BROWSER_EMULATION()
                    Dim bol As Boolean = (Me.lstRegKeyValue.SelectedIndex >= 0)
                    If bol = False Then
                        Me.cmdDeAktivieren.Text = "Vorschau IE-" & IEVer.Major & " deaktivieren"
                    End If
                    Me.cmdDeAktivieren.Enabled = bol
            End Select
        End With
    End Sub
End Class
